// WL_ACT1.C

#include "WL_DEF.H"
#pragma hdrstop

/*
=============================================================================

							STATICS

=============================================================================
*/


statobj_t	statobjlist[MAXSTATS],*laststatobj;


struct
{
	int		picnum;
	stat_t	type;
} statinfo[] =
{
{SPR_STAT_0,},	                         	// Teleporter 01   spr1v
{SPR_STAT_1,},		   	        	// Teleporter 02   "
{SPR_STAT_2,},			        	// Teleporter 03   "
{SPR_STAT_3,block},				// Floor lamp      "
{SPR_STAT_4},					// Chandelier      "
{SPR_STAT_5,block},				// Hanged man      "

#ifndef CONTEST
{SPR_STAT_6,bo_alpo},			        // Dog food        "
#else
{SPR_STAT_6,block},                             // Wooden logs     "
#endif

{SPR_STAT_7,block},				// Grey column     " 8
//
// NEW PAGE
//
{SPR_STAT_8,block},				// Plant in Grey   spr2v
{SPR_STAT_9},   			        // Water puddle    "
{SPR_STAT_10,block},			        // Statue          " 
{SPR_STAT_11,block},			        // Plant in Red    "
{SPR_STAT_12,block},			        // Desk            "
{SPR_STAT_13,block},			        // Table w/mugs    "
{SPR_STAT_14},   		         	// Green light     "
{SPR_STAT_15,block},			        // Cage w/blood    " 16
//
// NEW PAGE
//
{SPR_STAT_16,block},			        // Suit of armor   spr3v
{SPR_STAT_17,block},			        // Cage            "
{SPR_STAT_18,block},			        // Cage w/skeleton "
{SPR_STAT_19},					// Skeleton        "
{SPR_STAT_20,bo_key1},			        // Gold key        "
{SPR_STAT_21,bo_key2},			        // Key card        "
{SPR_STAT_22,block},			        // Bush 	   "
{SPR_STAT_23},					// stuff           " 24     
//
// NEW PAGE
//
{SPR_STAT_24,bo_food}, 			        // Food            spr4v
{SPR_STAT_25,bo_firstaid},		        // First aid       "
{SPR_STAT_26,bo_clip},			        // Clip            "
{SPR_STAT_27,bo_machinegun},     	        // Machine gun     "
{SPR_STAT_28,bo_chaingun},		        // Mmg01           "
{SPR_STAT_29,bo_cross},			        // Cross           "
{SPR_STAT_30,bo_chalice},		        // Chalice         "
{SPR_STAT_31,bo_bible},			        // Chest           " 32
//
// NEW PAGE
//
{SPR_STAT_32,bo_crown},			       // Crown           spr5v

#ifndef CONTEST
{SPR_STAT_33},		                       // Bones 1         "
#else 
{SPR_STAT_33,bo_alpo},                         // Snowy mine      "
#endif

{SPR_STAT_34,bo_gibs},			       // Bones 2         "
{SPR_STAT_35,block},		               // Barrel          "
{SPR_STAT_36,block},			       // Well            "
{SPR_STAT_37,block},			       // Empty well      "
{SPR_STAT_38,bo_gibs},			       // Blood           "
{SPR_STAT_39,block},			       // Flag 1          " 40
//
// NEW PAGE
//
{SPR_STAT_40},	         	               // Red light       spr6v
//
// NEW PAGE
//
{SPR_STAT_41,block},	         	       // Switch ON       "
{SPR_STAT_42},				       // Bones 3         "
{SPR_STAT_43},				       // Bones 4         "
{SPR_STAT_44,block},			       // Rack w/clothes 1"
{SPR_STAT_45,block},			       // Torso           " 
{SPR_STAT_46,block},			       // Rack w/clothes 2"
{SPR_STAT_47},			               // Vines	          " 48
//
// NEW PAGE
//
#ifdef SPEAR
{SPR_STAT_48,block},			       // Marble pillar   spr7v
{SPR_STAT_49,bo_25clip},		       // Ammobox (normal)"
{SPR_STAT_50,bo_glass},  		       // Portable medikit"
 #ifndef CONTEST
{SPR_STAT_51,bo_spear},			       // DOCUMENTS!!!    "
 #else
{SPR_STAT_51,block},
 #endif
#endif
{SPR_STAT_26,bo_clip2},			       // Clip            "
{SPR_OBJ0,bo_mmg2},                            // Mmg02           "
{SPR_OBJ1,bo_ammo2},                           // Mmg-Ammo        "
{SPR_OBJ2,bo_pistol},                          // Luger           " 56
//
// NEW PAGE
//
{SPR_OBJ3,block},                              // Tree            spr8v
{SPR_OBJ4,block},                              // Dead Tree       "
{SPR_OBJ5,block},                              // Stone           "
{SPR_OBJ6,bo_gem},                             // Diamond         "
{SPR_OBJ7},                                    // Boxes           "
{SPR_OBJ8,bo_poison},                          // Puddle of poison"
{SPR_ANIM0,block},                             // Torch           "
{SPR_ANIM4},                                   // Candles         " 64
//
// NEW PAGE
//
{SPR_ANIM6,block},                             // Stove           spr9v
{SPR_OBJ9},                                    // Corpse01        "
{SPR_OBJ10},                                   // Corpse02        "
{SPR_OBJ11},                                   // Corpse03        "
{SPR_OBJ12,},                                  // Gibs            " 
{SPR_OBJ13,block},                             // Opened machine  "
{SPR_OBJ14,block},                             // Desk w/machine  "
{SPR_OBJ15,block},                             // Desk w/stuff    " 72
//
// NEW PAGE
//
{SPR_OBJ16,block},                             // Table w/mugs    spr10v
{SPR_OBJ17},                                   // Statue 'o Hiter "
{SPR_OBJ18},                                   // Oil puddle      "
{SPR_OBJ19,block},                             // Dead doctor01   "
{SPR_HANG_0},                                  // Large Ghandalier"
{SPR_OBJ20,block},                             // Clothpole       " 
{SPR_OBJ21,block},                             // Light uniform   "
{SPR_OBJ22,block},                             // Dark  uniform   " 80
//
// NEW PAGE
//
{SPR_OBJ23,bo_poison},                         // Spikes          spr11v
{SPR_OBJ24,block},                             // Pod             "
{SPR_EMB_0,block},                             // Pod w/embryo    "
{SPR_OBJ25,block},                             // Flag 2          "
{SPR_OBJ26,block},                             // SS-flag         "
{SPR_OBJ27,block},                             // Flag 3          "
{SPR_OBJ28,bo_backpack},                       // Backpack        "
{SPR_OBJ29},                                   // Barebulb        " 88
//
// NEW PAGE
//
{SPR_OBJ30,block},                             // Black column 01 spr12v
{SPR_OBJ31,bo_key3},                           // Bronze key      " 
{SPR_OBJ32,bo_key4},                           // Rusty key       "
{SPR_OBJ33,bl_dir_south},                      // Fence 1d/south  "
{SPR_OBJ33,bl_dir_east},                       // Fence 1d/east   "
{SPR_OBJ34,bl_dir_south},                      // Fence 2 d/south "
{SPR_OBJ34,bl_dir_east},                       // Fence 2 d/east  "
{SPR_OBJ35,bl_dir_south},                      // Railing d/south " 96 
//
// NEW PAGE
//
{SPR_OBJ35,bl_dir_east},                       // Railing d/east  spr13v
{SPR_OBJ36,bl_dir_south},                      // Barbwire d/south"
{SPR_OBJ36,bl_dir_east},                       // Barbwire d/east "
{SPR_OBJ37,block},                             // Signpole        "
{SPR_OBJ38,bl_dir_south},                      // Blocks d/south  "
{SPR_OBJ39,bl_dir_east},                       // Blocks d/east   "
{SPR_OBJ40,bl_dir_south},                      // Steel d/south   " 
{SPR_OBJ41,bl_dir_east},                       // Steel d/east    " 112
//
// NEW PAGE
//
{SPR_OBJ42,bo_ammo2box},                       // Ammobox (MMg)   spr14v
{SPR_OBJ43,bl_dir_south},                      // Cell d/south    "
{SPR_OBJ44,bl_dir_east},                       // Cell d/east     "
{SPR_OBJ45,block},                             // Barrel          "
{SPR_OBJ46,dir_south},                         // Beams d/south   "
{SPR_OBJ46,dir_east},                          // Beams d/east    "
{SPR_OBJ47,dir_south},                         // Web d/south     "
{SPR_OBJ47,dir_east},                          // Web d/east      " 120
//
// NEW PAGE
//
{SPR_OBJ48},                                   // Bowels          spr15v
{SPR_OBJ49,dir_south},                         // Arch d/south    "
{SPR_OBJ49,dir_east},                          // Arch d/east     "
{SPR_OBJ50,block},                             // Nothing         "
{SPR_OBJ51,block},                             // Sink            "
{SPR_OBJ52,block},                             // Bed             "
{SPR_DROP1},                                   // Dropping water  " 
{SPR_OBJ53,bl_dir_south},                      // DGrau  d/south  " 128
//
// NEW PAGE
//
{SPR_OBJ54,bl_dir_east},                       // DGrau  d/east   spr16v
{SPR_OBJ55,block},                             // Nothing         "
{SPR_OBJ57,bl_dir_south},                      // Smoothe d/south "
{SPR_OBJ58,bl_dir_east},                       // Smoothe d/east  "
{SPR_OBJ59,bo_uniform},                        // Uniform         " 
{SPR_OBJ60},                                   // Dead rat        "
{SPR_OBJ61},                                   // Grab            "
{SPR_OBJ62,bl_dir_south},                      // Lab d/south     " 136
//
// NEW PAGE
//
{SPR_OBJ63,bl_dir_east},                       // Lab d/east      spr17v
{SPR_OBJ64,block},                             // Blue vase       "
{SPR_OBJ65,block},                             // Blue w/plant    "
{SPR_OBJ66},                                   // Hanging plant   "
{SPR_OPEN1,block},                             // Desk w/books 1  "
{SPR_OPEN2,block},                             // Table w/no mugs "
{SPR_OPEN3,block},                             // Black colum 2   "
{SPR_DEATHCAM,block},                          // Desk w/gore     " 144
//
// NEW PAGE
//
{SPR_DEMO,block},                              // Switch OFF      spr18v
{SPR_OBJ67,block},                             // Skulls on stick "
{SPR_OBJ68},                                   // Bloody bones02  "
{SPR_OBJ69,bl_dir_south},                      // Spears d/south  "
{SPR_OBJ69,bl_dir_east},                       // Spears d/east   "
{SPR_OBJ70,bl_dir_south},                      // Wood d/south    "
{SPR_OBJ71,bl_dir_east},                       // Wood d/east     "
{SPR_OBJ72,bl_dir_south},                      // SS-flag d/south " 152
//
// NEW PAGE
//
{SPR_OBJ72,bl_dir_east},                       // SS-flag d/east  spr19v
{SPR_OBJ73,bl_dir_south},                      // Swastika d/south"
{SPR_OBJ73,bl_dir_east},                       // Swastika d/east "
{SPR_TABLE01},                                 // Pot w/fire      "
{SPR_CANDLE01,block},                          // Candle hold     "
{SPR_FIRE01,bo_fire},                          // Campfire        "
{SPR_TEST01,block},                            // Surgeon w/body  "
{SPR_TEST02,block},                            // Surgeon         " 160
//
// NEW PAGE
//
{SPR_TEST03,block},                            // Surgeon w/blood spr20v
{SPR_METAL1,bl_dir_south},                     // Door 1 d/south  "
{SPR_METAL2,bl_dir_east},                      // Door 1 d/east   "
{SPR_METAL3,dir_south},                        // Door 2 d/south  "
{SPR_METAL4,dir_east},                         // Door 2 d/east   "
{SPR_OBJ74,block},                             // Brown vase      "
{SPR_OBJ75,block},                             // Brown w/plant   "
{SPR_OBJ76,bl_dir_south},                      // Stones d/south  " 168
//
// NEW PAGE
//
{SPR_OBJ77,bl_dir_east},                       // Stones d/east   spr21v
{SPR_LIFE01,bo_fullheal},                      // Life            " 
{SPR_GOD01,bo_godmode},                        // Invulnerability "
{SPR_BERSERK01,bo_berserk},                    // Berserk         "
{SPR_OBJ78,block},                             // Weapon rack     "
{SPR_OBJ79,block},                             // Empty statue    "
{SPR_OBJ80,block},                             // Statue Hermes   "
{SPR_OBJ81,block},                             // Statue Janus    " 176
//
// NEW PAGE
//
{SPR_OBJ82,block},                             // Statue Hitler   spr22v

{-1}					       // terminator
};

/*
===============
=
= InitStaticList
=
===============
*/

void InitStaticList (void)
{
	laststatobj = &statobjlist[0];
}



/*
===============
=
= SpawnStatic
=
===============
*/

void SpawnStatic (int tilex, int tiley, int type)
{
	laststatobj->shapenum = statinfo[type].picnum;
	laststatobj->tilex = tilex;
	laststatobj->tiley = tiley;
	laststatobj->visspot = &spotvis[tilex][tiley];

	switch (statinfo[type].type)
	{
	case block:
		(unsigned)actorat[tilex][tiley] = 1;		// consider it a blocking tile
	case dressing:
		laststatobj->flags = 0;
		break;

// Treasure:
	case	bo_cross:
	case	bo_chalice:
	case	bo_bible:
	case	bo_crown:
	case    bo_gem:
	case	bo_fullheal:
		if (!loadedgame)
		  gamestate.treasuretotal++;

// Keys:
	case	bo_key1:
	case	bo_key2:
	case	bo_key3:
	case	bo_key4:


// Health:
	case	bo_gibs:
	case	bo_alpo:
	case	bo_food:
	case	bo_firstaid:

	case    bo_poison:
	case    bo_glass:

// Ammunition:
	case	bo_clip:
	case	bo_25clip:

	case    bo_pistol:
	case	bo_machinegun:
	case	bo_chaingun:

	case    bo_ammo2:
        case    bo_ammo2box:
	case    bo_mmg2:

// Artefact:
	case    bo_berserk:
	case    bo_godmode:
	case	bo_spear:

// Other:
	case    bo_backpack:
	case    bo_uniform:

		laststatobj->flags = FL_BONUS;
		laststatobj->itemnumber = statinfo[type].type;
		break;

// Directional:
	case bl_dir_south:
	case bl_dir_south_fw:
	case bl_dir_south_bw:
	     (unsigned)actorat[tilex][tiley] = 1; // consider it a blocking tile
	case dir_south:
	case dir_south_fw:
	case dir_south_bw:
	     laststatobj->flags=FL_DIRSOUTH;
	     break;
	case bl_dir_east:
	case bl_dir_east_fw:
	case bl_dir_east_bw:
	     (unsigned)actorat[tilex][tiley] = 1; // consider it a blocking tile
	case dir_east:
	case dir_east_fw:
	case dir_east_bw:
	     laststatobj->flags=FL_DIREAST;
	     break;
   }
   switch(statinfo[type].type)
   {
      case dir_south_fw:
      case bl_dir_south_fw:
      case dir_east_fw:
      case bl_dir_east_fw:
	 laststatobj->flags|=FL_DIRFORWARD;
	 break;
      case dir_south_bw:
      case bl_dir_south_bw:
      case dir_east_bw:
      case bl_dir_east_bw:
	 laststatobj->flags|=FL_DIRBACKWARD;
	 break;

	}

	laststatobj++;

	if (laststatobj == &statobjlist[MAXSTATS])
		Quit ("Too many static objects!\n");
}


/*
===============
=
= PlaceItemType
=
= Called during game play to drop actors' items.  It finds the proper
= item number based on the item type (bo_???).  If there are no free item
= spots, nothing is done.
=
===============
*/

void PlaceItemType (int itemtype, int tilex, int tiley)
{
	int			type;
	statobj_t	*spot;

//
// find the item number
//
	for (type=0 ;  ; type++)
	{
		if (statinfo[type].picnum == -1)		// end of list
			Quit ("PlaceItemType: couldn't find type!");
		if (statinfo[type].type == itemtype)
			break;
	}

//
// find a spot in statobjlist to put it in
//
	for (spot=&statobjlist[0] ; ; spot++)
	{
		if (spot==laststatobj)
		{
			if (spot == &statobjlist[MAXSTATS])
				return;							// no free spots
			laststatobj++;						// space at end
			break;
		}

		if (spot->shapenum == -1)				// -1 is a free spot
			break;
	}
//
// place it
//
	spot->shapenum = statinfo[type].picnum;
	spot->tilex = tilex;
	spot->tiley = tiley;
	spot->visspot = &spotvis[tilex][tiley];
	spot->flags = FL_BONUS;
	spot->itemnumber = statinfo[type].type;
}



/*
=============================================================================

							DOORS

doorobjlist[] holds most of the information for the doors

doorposition[] holds the amount the door is open, ranging from 0 to 0xffff
	this is directly accessed by AsmRefresh during rendering

The number of doors is limited to 64 because a spot in tilemap holds the
	door number in the low 6 bits, with the high bit meaning a door center
	and bit 6 meaning a door side tile

Open doors conect two areas, so sounds will travel between them and sight
	will be checked when the player is in a connected area.

Areaconnect is incremented/decremented by each door. If >0 they connect

Every time a door opens or closes the areabyplayer matrix gets recalculated.
	An area is true if it connects with the player's current spor.

=============================================================================
*/

#define DOORWIDTH	0x7800
#define OPENTICS	300

doorobj_t	doorobjlist[MAXDOORS],*lastdoorobj;
int			doornum;

unsigned	doorposition[MAXDOORS];		// leading edge of door 0=closed
										// 0xffff = fully open

byte		far areaconnect[NUMAREAS][NUMAREAS];

boolean		areabyplayer[NUMAREAS];


/*
==============
=
= ConnectAreas
=
= Scans outward from playerarea, marking all connected areas
=
==============
*/

void RecursiveConnect (int areanumber)
{
	int	i;

	for (i=0;i<NUMAREAS;i++)
	{
		if (areaconnect[areanumber][i] && !areabyplayer[i])
		{
			areabyplayer[i] = true;
			RecursiveConnect (i);
		}
	}
}


void ConnectAreas (void)
{
	memset (areabyplayer,0,sizeof(areabyplayer));
	areabyplayer[player->areanumber] = true;
	RecursiveConnect (player->areanumber);
}


void InitAreas (void)
{
	memset (areabyplayer,0,sizeof(areabyplayer));
        if(player->areanumber < NUMAREAS) 
	   areabyplayer[player->areanumber] = true;
}



/*
===============
=
= InitDoorList
=
===============
*/

void InitDoorList (void)
{
	memset (areabyplayer,0,sizeof(areabyplayer));
	_fmemset (areaconnect,0,sizeof(areaconnect));

	lastdoorobj = &doorobjlist[0];
	doornum = 0;
}


/*
===============
=
= SpawnDoor
=
===============
*/

void SpawnDoor (int tilex, int tiley, boolean vertical, int lock)
{
	int	areanumber;
	unsigned	far *map;

	if (doornum==64)
		Quit ("64+ doors on level!");

	doorposition[doornum] = 0;		// doors start out fully closed
	lastdoorobj->tilex = tilex;
	lastdoorobj->tiley = tiley;
	lastdoorobj->vertical = vertical;
	lastdoorobj->lock = lock;
	lastdoorobj->action = dr_closed;

	(unsigned)actorat[tilex][tiley] = doornum | 0x80;	// consider it a solid wall

//
// make the door tile a special tile, and mark the adjacent tiles
// for door sides
//
	tilemap[tilex][tiley] = doornum | 0x80;
	map = mapsegs[0] + farmapylookup[tiley]+tilex;
	if (vertical)
	{
		*map = *(map-1);                        // set area number
		tilemap[tilex][tiley-1] |= 0x40;
		tilemap[tilex][tiley+1] |= 0x40;
	}
	else
	{
		*map = *(map-mapwidth);					// set area number
		tilemap[tilex-1][tiley] |= 0x40;
		tilemap[tilex+1][tiley] |= 0x40;
	}

	doornum++;
	lastdoorobj++;
}

//===========================================================================

/*
=====================
=
= OpenDoor
=
=====================
*/

void OpenDoor (int door)
{
	if (doorobjlist[door].action == dr_open)
		doorobjlist[door].ticcount = 0;			// reset open time
	else
		doorobjlist[door].action = dr_opening;	// start it opening
}


/*
=====================
=
= CloseDoor
=
=====================
*/

void CloseDoor (int door)
{
	int	tilex,tiley,area;
	objtype *check;

//
// don't close on anything solid
//
	tilex = doorobjlist[door].tilex;
	tiley = doorobjlist[door].tiley;

	if (actorat[tilex][tiley])
		return;

	if (player->tilex == tilex && player->tiley == tiley)
		return;

	if (doorobjlist[door].vertical)
	{
		if ( player->tiley == tiley )
		{
			if ( ((player->x+MINDIST) >>TILESHIFT) == tilex )
				return;
			if ( ((player->x-MINDIST) >>TILESHIFT) == tilex )
				return;
		}
		check = actorat[tilex-1][tiley];
		if (check && ((check->x+MINDIST) >> TILESHIFT) == tilex )
			return;
		check = actorat[tilex+1][tiley];
		if (check && ((check->x-MINDIST) >> TILESHIFT) == tilex )
			return;
	}
	else if (!doorobjlist[door].vertical)
	{
		if (player->tilex == tilex)
		{
			if ( ((player->y+MINDIST) >>TILESHIFT) == tiley )
				return;
			if ( ((player->y-MINDIST) >>TILESHIFT) == tiley )
				return;
		}
		check = actorat[tilex][tiley-1];
		if (check && ((check->y+MINDIST) >> TILESHIFT) == tiley )
			return;
		check = actorat[tilex][tiley+1];
		if (check && ((check->y-MINDIST) >> TILESHIFT) == tiley )
			return;
	}


//
// play door sound if in a connected area
//
	area = *(mapsegs[0] + farmapylookup[doorobjlist[door].tiley]
			+doorobjlist[door].tilex)-AREATILE;
	if (areabyplayer[area])
	{
		PlaySoundLocTile(CLOSEDOORSND,doorobjlist[door].tilex,doorobjlist[door].tiley);	// JAB
	}

	doorobjlist[door].action = dr_closing;
//
// make the door space solid
//
	(unsigned)actorat[tilex][tiley]
		= door | 0x80;
}



/*
=================================================
=
= OperateDoor
=
= The player wants to change the door's direction
=
=================================================
*/

void OperateDoor (int door)
{
	int	lock;

	lock = doorobjlist[door].lock;
	if (lock >= dr_lock1 && lock <= dr_lock4)
	{
		if ( ! (gamestate.keys & (1 << (lock-dr_lock1) ) ) )
		{
			SD_PlaySound (NOWAYSND);		// locked
			switch (lock)
			{
			case dr_lock1:
			     GetMessage("You need the Gold key to open this door.");
			     break;
			case dr_lock2:
			     GetMessage("You need the keycard to open this door.");
			     break;
			case dr_lock3:
			     GetMessage("You need the Bronze key to open this door.");
			     break;
			case dr_lock4:
			     GetMessage("You need the Rusty key to open this door.");
			     break;
			}
			return;
		}
	}

	switch (doorobjlist[door].action)
	{
	case dr_closed:
	case dr_closing:
		OpenDoor (door);
		break;
	case dr_open:
	case dr_opening:
		CloseDoor (door);
		break;
	}
}


//===========================================================================

/*
====================================
=
= DoorOpen
=
= Close the door after three seconds
=
====================================
*/

void DoorOpen (int door)
{
	if ( (doorobjlist[door].ticcount += tics) >= OPENTICS)
		CloseDoor (door);
}



/*
===============
=
= DoorOpening
=
===============
*/

void DoorOpening (int door)
{
	unsigned	area1,area2;
	unsigned	far	*map;
	long	position;

	position = doorposition[door];
	if (!position)
	{
	//
	// door is just starting to open, so connect the areas
	//
		map = mapsegs[0] + farmapylookup[doorobjlist[door].tiley]
			+doorobjlist[door].tilex;

		if (doorobjlist[door].vertical)
		{
			area1 =	*(map+1);
			area2 =	*(map-1);
		}
		else
		{
			area1 =	*(map-mapwidth);
			area2 =	*(map+mapwidth);
		}
		area1 -= AREATILE;
		area2 -= AREATILE;
                if(area1 < NUMAREAS && area2 < NUMAREAS) 
                { 
		   areaconnect[area1][area2]++;
		   areaconnect[area2][area1]++;
                   if(player->areanumber < NUMAREAS)
		      ConnectAreas ();
                }
		if (areabyplayer[area1])
		{
			PlaySoundLocTile(OPENDOORSND,doorobjlist[door].tilex,doorobjlist[door].tiley);	// JAB
		}
	}

//
// slide the door by an adaptive amount
//
	position += tics<<10;
	if (position >= 0xffff)
	{
	//
	// door is all the way open
	//
		position = 0xffff;
		doorobjlist[door].ticcount = 0;
		doorobjlist[door].action = dr_open;
		actorat[doorobjlist[door].tilex][doorobjlist[door].tiley] = 0;
	}

	doorposition[door] = position;
}


/*
===============
=
= DoorClosing
=
===============
*/

void DoorClosing (int door)
{
	unsigned	area1,area2,move;
	unsigned	far	*map;
	long	position;
	int		tilex,tiley;

	tilex = doorobjlist[door].tilex;
	tiley = doorobjlist[door].tiley;

	if ( ((unsigned)actorat[tilex][tiley] != (door | 0x80))
	|| (player->tilex == tilex && player->tiley == tiley) )
	{			// something got inside the door
		OpenDoor (door);
		return;
	};

	position = doorposition[door];

//
// slide the door by an adaptive amount
//
	position -= tics<<10;
	if (position <= 0)
	{
	//
	// door is closed all the way, so disconnect the areas
	//
		position = 0;

		doorobjlist[door].action = dr_closed;

		map = mapsegs[0] + farmapylookup[doorobjlist[door].tiley]
			+doorobjlist[door].tilex;

		if (doorobjlist[door].vertical)
		{
			area1 =	*(map+1);
			area2 =	*(map-1);
		}
		else
		{
			area1 =	*(map-mapwidth);
			area2 =	*(map+mapwidth);
		}

		area1 -= AREATILE;
		area2 -= AREATILE;
                if(area1 < NUMAREAS && area2 < NUMAREAS) 
                { 
   		   areaconnect[area1][area2]--;
		   areaconnect[area2][area1]--;
                   if(player->areanumber < NUMAREAS)  
		      ConnectAreas ();
                }
	}

	doorposition[door] = position;
}




/*
======================
=
= MoveDoors
=
= Called from PlayLoop
=
======================
*/

void MoveDoors (void)
{
	int		door;

	if (gamestate.victoryflag)		// don't move door during victory sequence
		return;

	for (door = 0 ; door < doornum ; door++)
		switch (doorobjlist[door].action)
		{
		case dr_open:
			DoorOpen (door);
			break;

		case dr_opening:
			DoorOpening(door);
			break;

		case dr_closing:
			DoorClosing(door);
			break;
		}
}


/*
=============================================================================

						PUSHABLE WALLS

=============================================================================
*/

unsigned	pwallstate;
unsigned	pwallpos;			// amount a pushable wall has been moved (0-63)
unsigned	pwallx,pwally;
int		pwalldir;
int             count; 

/*
===============
=
= PushWall
=
===============
*/

void PushWall (int checkx, int checky, int dir)
{
	int		oldtile;

	if (pwallstate)
	  return;


	oldtile = tilemap[checkx][checky];
	if (!oldtile)
		return;

	switch (dir)
	{
	case di_north:
		if (actorat[checkx][checky-1])
		{
			SD_PlaySound (NOWAYSND);
			return;
		}
		(unsigned)actorat[checkx][checky-1] =
		tilemap[checkx][checky-1] = oldtile;
		break;

	case di_east:
		if (actorat[checkx+1][checky])
		{
			SD_PlaySound (NOWAYSND);
			return;
		}
		(unsigned)actorat[checkx+1][checky] =
		tilemap[checkx+1][checky] = oldtile;
		break;

	case di_south:
		if (actorat[checkx][checky+1])
		{
			SD_PlaySound (NOWAYSND);
			return;
		}
		(unsigned)actorat[checkx][checky+1] =
		tilemap[checkx][checky+1] = oldtile;
		break;

	case di_west:
		if (actorat[checkx-1][checky])
		{
			SD_PlaySound (NOWAYSND);
			return;
		}
		(unsigned)actorat[checkx-1][checky] =
		tilemap[checkx-1][checky] = oldtile;
		break;
	}

	gamestate.secretcount++;
	pwallx = checkx;
	pwally = checky;
	pwalldir = dir;
	pwallstate = 1;
	pwallpos = 0;
	tilemap[pwallx][pwally] |= 0xc0;
	*(mapsegs[1]+farmapylookup[pwally]+pwallx) = 0;	// remove P tile info

	SD_PlaySound (PUSHWALLSND);
	GetMessage("Found a secret area.");
}



/*
=================
=
= MovePWalls
=
=================
*/

void MovePWalls (void)
{
	int		oldblock,oldtile;

	if (!pwallstate)
		return;

	oldblock = pwallstate/128;

	pwallstate += tics;

	if (pwallstate/128 != oldblock)
	{
	// block crossed into a new block
		oldtile = tilemap[pwallx][pwally] & 63;

		//
		// the tile can now be walked into
		//
		tilemap[pwallx][pwally] = 0;
		(unsigned)actorat[pwallx][pwally] = 0;
		*(mapsegs[0]+farmapylookup[pwally]+pwallx) = player->areanumber+AREATILE; 
                count++; 


		//
		// see if it should be pushed farther
		//
		if (count == 4) //this used to be "if (pwallstate>256)" 
		{
		//
		// the block has been pushed four tiles
		//
			pwallstate = count = 0;
			return;
		}
		else
		{
			switch (pwalldir)
			{
			case di_north:
				pwally--;
				if (actorat[pwallx][pwally-1])
				{
					pwallstate = count = 0;
					return;
				}
				(unsigned)actorat[pwallx][pwally-1] =
				tilemap[pwallx][pwally-1] = oldtile;
				break;

			case di_east:
				pwallx++;
				if (actorat[pwallx+1][pwally])
				{
					pwallstate = count = 0;
					return;
				}
				(unsigned)actorat[pwallx+1][pwally] =
				tilemap[pwallx+1][pwally] = oldtile;
				break;

			case di_south:
				pwally++;
				if (actorat[pwallx][pwally+1])
				{
					pwallstate = count = 0;
					return;
				}
				(unsigned)actorat[pwallx][pwally+1] =
				tilemap[pwallx][pwally+1] = oldtile;
				break;

			case di_west:
				pwallx--;
				if (actorat[pwallx-1][pwally])
				{
					pwallstate = count = 0;
					return;
				}
				(unsigned)actorat[pwallx-1][pwally] =
				tilemap[pwallx-1][pwally] = oldtile;
				break;
			}

			tilemap[pwallx][pwally] = oldtile | 0xc0;
		}
	}


	pwallpos = (pwallstate/2)&63;

}

